// This may look like C code, but it is really -*- C++ -*-

//   Module      : Field.h   Version 1.2
//   LastSCCS    : 2/26/92  16:38:43
//   LastEdit    : "Fri Nov  8 13:40:45 1991"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

#ifndef Field_h
#define Field_h

class Player;

class Field : public PlayerLocation {
    friend class Player;
  protected:
    Field(Player *p_player, Card *p_card,
	  int p_shape, int p_color, int p_value);
    FieldStatus SetState(FieldStatus p_field_status);
  public:
    Card *GetCard()
	{ return card; }
    FieldStatus GetState()
	{ return field_status; }
    void Change(FieldStatus new_status);
  public: // Predicates
    Boolean IsNeutral()
	{ return field_status == eNeutral; }
    Boolean IsOwned()
	{ return field_status == eOwned; }
    Boolean IsNotOwned()
	{ return field_status == eNotOwned; }
  private:
    Card        *card;
    FieldStatus  field_status;
};

DefGenericListWithIterator(FieldList,Field,FieldListIterator);

#endif
